/*
   AnalogThermometer2
   Hőmérés MCP9700 hőmérővel. Az A4 analóg bementre (pin 6)
   kötött MCP9700 hőmérő jelét a beépített 1.5 V-os referenciához 
   képest mérjük, az eredményt Celsius fokokra átszámítjuk.
   
   A statisztikus ingadozás csökkentés érdekében
   minden ciklusban 1500 mérést végzünk és átlagolunk. 
   A soros porton kiíratjuk az ADC-ből kapott nyers adatot 
   és az átszámított eredményt is. A mérések között egymásodperces 
   szünetet tartunk.
   
   Az MCP9700 hőmérő nullapontja = 500 mV, érzékenysége = 10 mV/C
  
   A program eredetije Arduino kártyához készült, lelőhelye: 
     http://arms22.blog91.fc2.com/blog-entry-415.html
   MSP430 Launchpadra adaptálta és módosította: Cserny István
 */

long mysum;           //ebben összegezzük az eredményt

void setup ()
{
   Serial.begin(9600);
   analogReference(INTERNAL1V5);
}

void loop ()
{
   // Get the output voltage of the MCP9700
   mysum = 0;
   for(int i=0; i<1500; i++) {
      mysum += analogRead (A4);
   }
   // Convert to an AD mV value
   float voltage = mysum>>10;   //Divide by 1024

   Serial.print (voltage,0);
   Serial.print (" mV, ");

   // Convert mV to Celsius temperature [C]
   float tempC = (voltage - 500) / 10;

   Serial.print (tempC,1);
   Serial.print (" C, ");

   // Convert from Celsius to Fahrenheit [F]
   float tempF = (tempC * 9/5) + 32;

   Serial.print (tempF,1);
   Serial.println (" F");

   delay (1000);
}
