/*
   AnalogThermometer3
   Hőmérés MCP9700 hőmérővel. Az A4 analóg bementre (pin 6)
   kötött MCP9700 hőmérő jelét a beépített 1.5 V-os referenciához 
   képest mérjük.
   
   A statisztikus ingadozás csökkentés érdekében
   minden ciklusban 1500 mérést végzünk és átlagolunk, 
   a kapott eredményt Celsius fokokra átszámítjuk és soros
   porton keresztül kiíratjuk.
   
   A kiíratást a TRHlogger programmal kompatibilis módon végezzük, 
   kamu páratartalom adattal... 
   
   Az MCP9700 hőmérő nullapontja = 500 mV, érzékenysége = 10 mV/C
  
   A program eredetije Arduino kártyához készült, lelőhelye: 
     http://arms22.blog91.fc2.com/blog-entry-415.html
   
   A TRHlogger program eredeti programja Rajendra Bhatt 
   honlapjáról szármaazik: http://embedded-lab.com/blog/?p=5453
   MSP430 Launchpadra adaptálta és módosította: Cserny István
 */
long mysum;           //ebben összegezzük az eredményt

void setup ()
{
   Serial.begin(9600);
   analogReference(INTERNAL1V5);
}

void loop ()
{
   // Get the output voltage of the MCP9700
   mysum = 0;
   for(int i=0; i<1500; i++) {
      mysum += analogRead (A4);
   }
   // Convert to an AD mV value
   float voltage = mysum>>10;   //Osztás 1024-gyel
   float rh = voltage;
   // Konvertálás mV-ból Celsius fokokra [C]
   float tempC = (voltage - 500) / 10;
   Serial.print(rh/10,1);  //kamu RH érték kiírása...
   Serial.print(" ");
   Serial.println(tempC,1);
   delay (2000);
}
