/*
  Photoresistor
  Fényérzékelés fotoellenállás (LDR) segítségével, amelyet egy 
  feszültségosztó felső tagjának kötónk be.
  
          LDR      10k
    VCC--/\/\/\-+-/\/\/\--- GND 
                |
                A3
               
    A mért feszültség értékét a soros porton kiíratjuk.            
 */

long mysum;           //ebben összegezzük az eredményt

void setup ()
{
   Serial.begin(9600);
   analogReference(DEFAULT);   //VCC a referencia: 3.5 V
}

void loop ()
{
   //Feszültségmérés átlagolással
   mysum = 0;
   for(int i=0; i<3500; i++) {
      mysum += analogRead (A3);
   }
   // Átszámítás mV egységekre
   float voltage = mysum>>10;   //Osztás 1024-gyel

   Serial.print(voltage,0);
   Serial.print(" mV, ");
   // Átszámítás kOhm-ra
   // Rx = VCC*10k/voltage - 10k
   float rx = 35000/voltage - 10;
   Serial.print(rx,3);
   Serial.println(" kOhm");
   delay (1000);
}
